diff -ur old/gettext-tools/lib/execute.c new/gettext-tools/lib/execute.c
--- old/gettext-tools/lib/execute.c	2004-01-05 11:48:31.000000000 +0100
+++ new/gettext-tools/lib/execute.c	2010-01-12 08:37:07.000000000 +0100
@@ -71,6 +71,14 @@
 # define STDERR_FILENO 2
 #endif
 
+#ifndef HAVE_ENVIRON_DECL
+# ifdef __APPLE__
+# include <crt_externs.h>
+# define environ (*_NSGetEnviron())
+# else
+extern char **environ;
+# endif
+#endif
 
 #ifdef EINTR
 
diff -ur old/gettext-tools/lib/pipe-bidi.c new/gettext-tools/lib/pipe-bidi.c
--- old/gettext-tools/lib/pipe-bidi.c	2010-01-12 08:39:11.000000000 +0100
+++ new/gettext-tools/lib/pipe-bidi.c	2010-01-12 08:37:59.000000000 +0100
@@ -70,6 +70,14 @@
 # define STDERR_FILENO 2
 #endif
 
+#ifndef HAVE_ENVIRON_DECL
+# ifdef __APPLE__
+# include <crt_externs.h>
+# define environ (*_NSGetEnviron())
+# else
+extern char **environ;
+# endif
+#endif
 
 #ifdef EINTR
 
diff -ur old/gettext-tools/lib/pipe-in.c new/gettext-tools/lib/pipe-in.c
--- old/gettext-tools/lib/pipe-in.c	2003-10-15 12:15:23.000000000 +0200
+++ new/gettext-tools/lib/pipe-in.c	2010-01-12 08:39:25.000000000 +0100
@@ -70,6 +70,14 @@
 # define STDERR_FILENO 2
 #endif
 
+#ifndef HAVE_ENVIRON_DECL
+# ifdef __APPLE__
+# include <crt_externs.h>
+# define environ (*_NSGetEnviron())
+# else
+extern char **environ;
+# endif
+#endif
 
 #ifdef EINTR
 
diff -ur old/gettext-tools/lib/pipe-out.c new/gettext-tools/lib/pipe-out.c
--- old/gettext-tools/lib/pipe-out.c	2003-10-15 12:15:23.000000000 +0200
+++ new/gettext-tools/lib/pipe-out.c	2010-01-12 08:39:30.000000000 +0100
@@ -70,6 +70,14 @@
 # define STDERR_FILENO 2
 #endif
 
+#ifndef HAVE_ENVIRON_DECL
+# ifdef __APPLE__
+# include <crt_externs.h>
+# define environ (*_NSGetEnviron())
+# else
+extern char **environ;
+# endif
+#endif
 
 #ifdef EINTR
 
diff -ur old/gettext-tools/lib/setenv.c new/gettext-tools/lib/setenv.c
--- old/gettext-tools/lib/setenv.c	2003-12-27 16:36:35.000000000 +0100
+++ new/gettext-tools/lib/setenv.c	2010-01-12 08:35:24.000000000 +0100
@@ -42,8 +42,13 @@
 #if !_LIBC
 # define __environ	environ
 # ifndef HAVE_ENVIRON_DECL
+# ifdef __APPLE__
+# include <crt_externs.h>
+# define environ (*_NSGetEnviron())
+# else
 extern char **environ;
 # endif
+# endif
 #endif
 
 #if _LIBC
